cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                      c
c                         common decks for HUMBER                      c
c                                                                      c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      use dflib
      implicit none
            
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                      c
c                          CONTROL VARIABLES                           c
c                                                                      c
c   fexist = file existance flag                                       c
c   inex = input file flag                                             c
c   outex = output file flag                                           c
c   datex = data file flag                                             c
c                                                                      c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      
      logical fexist,inex,outex,datex,cimode,dubenc
            
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                      c
c                     GENERAL COUNTING VARIABLES                       c
c                                                                      c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      integer*8 i,j,k,l,m,n
      integer p,q,r,s

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                      c
c                     MESSAGE PROCESSING INTEGERS                      c
c                                                                      c
c texlen = length of text string                                       c
c                                                                      c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      integer*4 number, numb, numb1,mescnt
      integer*8 texlen,crplen
      
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                      c
c                  VARIABLES FOR PROCESSING TEXT DATA                  c
c                                                                      c
c hedtex = header text                                                 c
c hedout = header text for output                                      c
c text1, text2, text3 are general text holders                         c
c                                                                      c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      character*18 hedtex
      character*100 text1,text2,text3,hedout
      character*32 keydat(64)
      character*8 dated

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                      c
c                        REGISTER VARIABLES							   c
c                                                                      c
c reg = index register                           					   c
c sreg = shift register                                                c
c reg1 = index register for second encryption     					   c
c sreg = shift register for second encryption                          c
c                                                                      c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      integer*2 reg(256), reg1(256), sreg(256), sreg1(256)
	
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                      c
c                          ROTATION VARIABLES						   c
c                                                                      c
c advan = message number                                               c
c advan1 = number of rotations for the shift register                  c
c advan2 = number of rotations for the index register                  c
c                                                                      c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      integer*8 advan,advan1,advan2
      integer*2 hash(4),alpha(3)
      character*8 hdrhsh,hdrnum,mesnum
      character*256 headpl,hdcryp
      
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                      c
c                         CONSTANTS                                    c
c                                                                      c
c shlen = length of shift register                                     c
c reglen = length of index register                                    c
c hedlen = length of message header                                    c
c hedln2 = length of message header including hash                     c
c meslim = maximum number of messages for one key file                 c
c keylim = total number of key files                                   c
c shftad = number of shifts to rotate shift register                   c
c regadv = number of shifts to rotate index register                   c
c                                                                      c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      integer shlen,reglen,hedlen,hedln2,meslim,keylim
      character*7 hmbr
      parameter (hmbr = '.humber')
      parameter (shlen=256, reglen=256, hedlen=18,hedln2=18)
      parameter (meslim=9999, keylim=17576) 
     
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                      c
c                         FILE     VARIABLES                           c
c                                                                      c
c infile = input file name                                             c
c outfil = encrypted file name for transmission                        c
c encfil = encrypted file name for decryption                          c
c finfil = final plaitext file                                         c
c datfil = file for register keys                                      c
c indfil = file for last values of message sttings                     c
c lstfil = list of available key files                                 c
c mesfil = list of files in messages folder                            c
c crpfil = list of files in encryted folder                            c
c pltfil = list of files in plaintext folder                           c
c mesnam = name of ith file in message folder                          c
c                                                                      c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      character*100 infile,outfil,encfil,finfil,datfil,indfil,lstfil
      character*100 mesfil,crpfil,pltfil,donfil,dmpfil
      character*100 mesnam(meslim),crpnam(meslim)
      character*16 keynam(keylim)
     
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                      c
c                         DIALOGUE VARIABLES                           c
c                                                                      c
c infile = input file name                                             c
c outfil = encrypted file name for transmission                        c
c encfil = encrypted file name for decryption                          c
c finfil = final plaitext file                                         c
c datfil = file for register keys                                      c
c indfil = file for directory list                                     c
c                                                                      c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      integer fcount
      integer*4 cursor, oldcursor, length 
      integer*2 oldcur, istat, cline
      character messge*40,emess*30
      character ans*1,tans*1
      
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                      c
c                             COMMON  BLOCKS                           c
c                                                                      c
c blk000/1    program control variables                                c
c blk002      source particles										   c
c blk003/4    resevoirs			                                       c
c blk005      particle variables									   c
c blk006/7    file variables										   c
c                                                                      c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


!      common/blk000/i,j,k,l,m,n
      common/blk001/number,numb,numb1,mescnt
      common/blk002/texlen,crplen
      common/blk003/text1,text2,text3,hedout
      common/blk004/reg,reg1,sreg,sreg1
      common/blk005/advan,advan1,advan2,hash,alpha
      common/blk006/infile,outfil,encfil,finfil,datfil,indfil,lstfil
      common/blk007/mesfil,crpfil,pltfil,donfil,dmpfil
      common/blk008/mesnam,crpnam,keynam
      common/blk010/hedtex,hdrhsh,hdrnum,mesnum
      common/blk11/oldcur, istat, cline
      common/blk12/ans,tans
      common/blk13/messge,emess
      common/blk14/cimode,dubenc
      common/blk15/keydat,headpl,hdcryp


