      subroutine encryp

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc                                                                    cc
cc                                                                    cc
cc                                                                    cc
cc                                                                    cc
cc                                                                    cc
cc   EEEEEEEE  N       N    CCCCCC   RRRRRRR   Y       Y PPPPPPP      cc
cc   E         NN      N   C      C  R      R   Y     Y  P      P     cc
cc   E         N N     N  C          R       R   Y   Y   P       P    cc
cc   E         N  N    N  C          R      R     Y Y    P      P     cc
cc   EEEEEE    N   N   N  C          RRRRRRR       Y     PPPPPPP      cc
cc   E         N    N  N  C          R      R      Y     P            cc
cc   E         N     N N  C          R       R     Y     P            cc
cc   E         N      NN   C      C  R       R     Y     P            cc
cc   EEEEEEEE  N       N    CCCCCC   R       R     Y     P            cc
cc                                                                    cc
cc                                                                    cc
cc                                                                    cc
cc                                                                    cc
cc                                                                    cc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc                                                                    cc
cc  This subroutine ecrypts the message one character at a time       cc
cc  and adds a hex pair for each to the output stream                 cc
cc                                                                    cc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      include 'common.for'
      character*30000000 intext
      character*30000000 outext
      integer icnt,srtmp,sr1tmp
	integer*8 iran,tempsr
      real rec56
      parameter (rec56=2.0**(-56))
      integer*8 two7,two32,prim32
      parameter (two7=127,two32=2.0**32)
      parameter (prim32=two32+1)
      
c Ensure output stream is empty
      intext = " "
c Open file with plain language message for encryption
      open (5,file = infile,recordtype = 'stream',blocksize=65536)
      n = 1 ! postion in stream of first character in block to be added
c Check for end of file.
      do while (.not. EOF(5))
c Read line of data.
          read(5,'(a)') outext
          if (eof(5)) then
              k = len_trim(outext) ! length of final block
          else
              k = 65536 ! default length of block
          end if
          m = n + k - 1 ! postion of last character in stream
c Add input data to output stream
          write(intext(n:m),'(a)') outext(1:k)
          n = m + 1
      end do
      outex = ""
c set length of inpt stream
      texlen = Len_trim(intext)          
      close (5)

c write header for output
      call headw ! create encrypted header
!      call datain ! re-read in key data       
c rotate registers to correct starting position for message
      call rotate ! also apply hash
      messge = 'Encrypting File '
      tans = 'n' ! do not await key depression
      call dialog
      
c Set postion of pointer to beginning of message text
      i = 0  
      iran=123456789 
c Process each character in turn
      Do While (i .lt. texlen)
           i = i + 1          
c Capture ASCII value of each character in message
          number = iachar(intext(i:i))        
c Insert new number into highest shift register element
          srtmp = ieor(number,sreg(1))
c Capture number from index register
          numb = reg(sreg(1) + 1)
c Encipher character
          number = ieor(number,numb)
c Insert new number into highest shift register element
          sr1tmp = ieor(number,sreg1(1))
c Capture number from index register
          numb = reg1(sreg1(1) + 1)
c Encipher character
          number = ieor(number,numb)
                          
          if (cimode) then ! write output as hex
      
c calculate position in output stream to add hex characters
              j = i*3 - 2
c Convert to Hex and add to output stream with trailing space
              
              write(outext(j:j+1),'(z2.2)') number
              write(outext(j+2:j+2),'(a1)') char(32) 
           else ! write to output stream
               j = i
!               write(outext(j:j),'(a1)') char(number) 
               outext(i:i) = char(number)
           end if                  
c Perform shift right on shift registers
           do k = 1, shlen - 1
               sreg(k) = sreg(k + 1)
               sreg1(k) = sreg1(k + 1)
          end do     
! random elements added to shift register rotation
          iran = iran * prim32 + 1
          tempsr=rec56*iran + two7
          srtmp = ieor(srtmp,tempsr) 
          sreg(shlen) = srtmp   
          iran = iran * prim32 + 1
          tempsr=rec56*iran + two7
          sr1tmp = ieor(sr1tmp,tempsr)    
          sreg1(shlen) = sr1tmp  
      end do 
      texlen = len_trim(outext)
            
c Write encrypted message to output file

      open (5,file = outfil) 
!      write (5,'(a)') (hedout(1:hedlen))
      write (5,'(a)') (hdcryp(1:crplen))
      write (5,'(a)') (outext(1:texlen))
      close (5)
       
      return

      end