      subroutine hasher

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc                                                                    cc
cc                                                                    cc
cc                                                                    cc
cc                                                                    cc
cc                                                                    cc
cc   H       H    AAAAA       SSS    H       H  EEEEEEEE RRRRRR       cc
cc   H       H   A     A    S     S  H       H  E        R     R      cc
cc   H       H  A       A  S         H       H  E        R      R     cc
cc   H       H  A       A   S        H       H  E        R     R      cc
cc   HHHHHHHHH  AAAAAAAAA     SSS    HHHHHHHHH  EEEEEEE  RRRRRR       cc
cc   H       H  A       A         S  H       H  E        R     R      cc
cc   H       H  A       A          S H       H  E        R      R     cc
cc   H       H  A       A   S     S  H       H  E        R      R     cc
cc   H       H  A       A     SSS    H       H  EEEEEEEE R      R     cc
cc                                                                    cc
cc                                                                    cc
cc                                                                    cc
cc                                                                    cc
cc                                                                    cc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc                                                                    cc
cc  This subroutine generates a hash to modify the contents of the    cc
cc  registers                                                         cc
cc                                                                    cc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      include 'common.for'
      integer*8 icnt,icnt2,ilim 
      logical pressd
      character*12 snap(2)
	integer tnow,icnt3
      
      integer*8 two24,two31,two32,two15
      parameter (two24=2.0**24,two31=2.0**31,two32=2.0**32)
      parameter (two15=2.0**15)
	integer*8 iran, inhash
	integer prim4
	integer*2 keytop
	integer*8 two63,srtmp,sr1tmp
      integer*8 prim15,prim16,prim32,prim31
      real*8 rec8,rec24,rec31,rec32,rec64,rec39,rec48
	Parameter (prim4 = 17,two63 = 2**63 - 1)
      parameter (prim15=32771,prim16=65539,prim31=two31 - 1)
      parameter (prim32=two32+21)
      parameter (rec24=2.0**(-24),rec31=2.0**(-31),rec32=2.0**(-32))
      parameter (rec64=2.0**(-64),rec8=2.0**(-8),rec39=2.0**(-39))
      parameter (rec48=2.0**(-48))
	
! set up generator to generate hash and message rotation number
      messge = 'Generating hash for encryption'
      tans = 'n' ! do not await key depression
      call dialog
      iran=123456789 ! initial value for random number
      iran=iran*prim32 + 1
      icnt = 0 ! count of total iterations
      icnt2 = 0 ! count for current cycle
      call date_and_time(snap(1),snap(2)) ! system date & time
      read (snap(2)(10:10),'(i3.3)')tnow ! milliseconds unit value
      
!      generate hash for encryption
      icnt3 = 0 ! count of total cycles
      pressd = .false. ! allow generation to start
      do while (.not. pressd)
          iran = -iran ! negate current random value
          ilim = (rec39*iran + two24)*(tnow + 1)/16 
          do icnt2 = 1,ilim ! number of iterations for current cycle    
              iran=iran*prim32+1
              icnt = icnt + 1
          end do
          icnt3 = icnt3 + 1
          call date_and_time(snap(1),snap(2)) ! system date & time
          read (snap(2)(10:10),'(i3.3)')tnow ! milliseconds unit value
          if ((tnow. eq. 0) .and. (icnt3 .gt.9)) pressd = .true. 
      end do
      inhash = iran*rec32 + two31
      write(hdrhsh(1:8),'(z8.8)') inhash ! hash number in hex
      
!      generate rotation index
      icnt3 = 0 ! count of total cycles
      pressd = .false. ! allow generation to start
      do while (.not. pressd)
          iran = -iran ! negate current random value
          ilim = (rec39*iran + two24)*(tnow + 1)/16 
          do icnt2 = 1,ilim ! number of iterations for current cycle    
              iran=iran*prim32+1
              icnt = icnt + 1
          end do
          icnt3 = icnt3 + 1
          call date_and_time(snap(1),snap(2)) ! system date & time
          read (snap(2)(10:10),'(i3.3)')tnow ! milliseconds unit value
          if ((tnow. eq. 0) .and. (icnt3 .gt.9)) pressd = .true. 
      end do
      inhash = iran*rec32 + two31
      write(hdrnum,'(z8.8)')inhash ! rotation index in hex
      
!      generate message number
      icnt3 = 0 ! count of total cycles
      pressd = .false. ! allow generation to start
      do while (.not. pressd)
          iran = -iran ! negate current random value
          ilim = (rec39*iran + two24)*(tnow + 1)/16 
          do icnt2 = 1,ilim ! number of iterations for current cycle    
              iran=iran*prim32+1
              icnt = icnt + 1
          end do
          icnt3 = icnt3 + 1
          call date_and_time(snap(1),snap(2)) ! system date & time
          read (snap(2)(10:10),'(i3.3)')tnow ! milliseconds unit value
          if ((tnow. eq. 0) .and. (icnt3 .gt.9)) pressd = .true. 
      end do
      inhash = iran*rec32 + two31
      write(mesnum,'(z8.8)')inhash ! message number in hex

      return	

      end