      subroutine rotate

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc                                                                    cc
cc                                                                    cc
cc                                                                    cc
cc                                                                    cc
cc                                                                    cc
cc     RRRRRR      OOOOO   TTTTTTTTT   AAAA    TTTTTTTTT EEEEEEEEE    cc
cc     R     R    O     O      T      A    A       T     E            cc
cc     R      R  O       O     T     A      A      T     E            cc
cc     R     R   O       O     T     A      A      T     E            cc
cc     RRRRRR    O       O     T     AAAAAAAA      T     EEEEEEE      cc
cc     R     R   O       O     T     A      A      T     E            cc
cc     R      R  O       O     T     A      A      T     E            cc
cc     R      R   O     O      T     A      A      T     E            cc
cc     R      R    OOOOO       T     A      A      T     EEEEEEEEE    cc
cc                                                                    cc
cc                                                                    cc
cc                                                                    cc
cc                                                                    cc
cc                                                                    cc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc                                                                    cc
cc  This subroutine rotates the index and shift registers to the      cc
cc  required start settings for the message                           cc
cc                                                                    cc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      include 'common.for'
      
!c Allow for message 1 to use the intitial day settings
!      advan = advan - 1
!c Calculate the number of rotations for the shift register
!      advan1 = Int(advan / reglen)
!c Reduce rotations for the index register to a single pass
!      advan2 = mod(advan, reglen)
!      
      read(hdrnum(1:2),'(z2)') advan
      i = 1
c Carry out each rotation of shift register
      do while (i .le. advan)
c Capture value in lowest element of array
            k = sreg(1)
c Carry out for each element of array
            do j = 1, shlen - 1
c Copy down the value from the next element
                sreg(j) = sreg(j + 1)
            end do
c Copy value from lowest element of array to highest element
            sreg(shlen) = k
c Increment rotation counter
            i = i + 1
      end do
      
      read(hdrnum(3:4),'(z2)') advan
      i = 1
c Carry out each rotation of shift register 1
      do while (i .le. advan)
c Capture value in lowest element of array
            m = sreg1(1)
c Carry out for each element of array
            do j = 1, shlen - 1
c Copy down the value from the next element
                sreg1(j) = sreg1(j + 1)
            end do
c Copy value from lowest element of array to highest element
            sreg1(shlen) = m
c Increment rotation counter
            i = i + 1
      end do
      
      read(hdrnum(5:6),'(z2)') advan
      i = 1
c Carry out each rotation of shift register
      do while (i .le. advan)
c Capture value in lowest element of array
            k = reg(1)
c Carry out for each element of array
            do j = 1, reglen - 1
c Copy down the value from the next element
                reg(j) = reg(j + 1)
            end do
c Copy value from lowest element of array to highest element
            reg(reglen) = k
c Increment rotation counter
            i = i + 1
      end do
      
      read(hdrnum(7:8),'(z2)') advan
      i = 1
c Carry out each rotation of shift register 1
      do while (i .le. advan)
c Capture value in lowest element of array
            m = reg1(1)
c Carry out for each element of array
            do j = 1, reglen - 1
c Copy down the value from the next element
                reg1(j) = reg1(j + 1)
            end do
c Copy value from lowest element of array to highest element
            reg1(reglen) = m
c Increment rotation counter
            i = i + 1
      end do
      
! XOR hash values with register values
      do i = 1,4
          read(hdrhsh(i*2-1:i*2),'(z2)') hash(i)
!          write(*,*) i,hash(i)
      end do
      do i = 1, 256
          reg(i:i) = ieor(reg(i:i),hash(1))
          reg1(i:i) = ieor(reg1(i:i),hash(2))
          sreg(i:i) = ieor(sreg(i:i),hash(3))
          sreg1(i:i) = ieor(sreg1(i:i),hash(4))
      end do      
      
      return

      end